# Contributing Guide

## Getting started

### Prerequisites
- Go 1.21 or later

### Development Commands
The project uses Make for common development tasks:

```bash
make build      # Build harcleaner and hargen binaries
make test       # Run all tests
make benchmark  # Run benchmark tests
make clean      # Remove build artifacts
```

For example, to build and test:

```bash
make build
make test
```

### Benchmark Comparison
The project monitors performance changes using benchmark comparisons. A regression threshold of 5% is used to detect significant performance changes.
To compare benchmark results locally:

```bash
# Run benchmarks and save results
make benchmark > old_benchmark.txt
# Make changes, then run new benchmarks
make benchmark > new_benchmark.txt
# Compare results (will fail if regression > 5%)
make benchmark-compare OLD=old_benchmark.txt NEW=new_benchmark.txt
```

The comparison shows:

- Time per operation changes (regression threshold: 5%)
- Memory allocation changes
- Object allocation changes

The CI pipeline automatically compares benchmark results against the main branch using these same thresholds.

### CI/CD and Releases

- `goreleaser` is used for CI/CD builds and releases
- Releases occur once a Git tag is created
- Local development can use make build instead

### Submitting a merge request
1. Create a new branch: `git checkout -b my-branch-name`
1. Make your change, add tests, and ensure tests pass
1. Submit a merge request

### Code Formatting

This project follows standard Go formatting conventions using `gofmt`. The CI pipeline will check formatting and fail if any files need formatting.

To check formatting:
```bash
make format-check   # Show files that need formatting
```

To apply formatting:
```bash
make format-apply   # Format all Go files
```

Run `make format-check` before committing to ensure your changes meet the formatting requirements. The CI pipeline runs the same check to enforce consistent code style.

## Commit Messages

The below guidelines have been based on the `gitlab-org/cli` [project](https://gitlab.com/gitlab-org/cli/-/blob/main/CONTRIBUTING.md?plain=0#commit-messages). The guidelines help produce cleaner
and more readable commit messages, and a more coherent changelog generated by `goreleaser`.

Each commit message should consist of a **header**, a **body**, and a **footer**. The header has a special format that includes a **type**, a **scope**, and a **description**:

```plaintext
<type>(<scope>): <description>
<BLANK LINE>
<body>
<BLANK LINE>
<footer>
```

Each line in the commit message should be no longer than 72 characters.

### Message Header

The message header is mandatory, and should be a single line that contains a succinct description of the change containing a type, an optional scope, and a description. Ideally, it should not be more than 50 characters in length.

Following these conventions results in a clear changelog for every version.

It's generally a good idea to follow the conventions for your MR's title as well as for commit messages. This way, if your merge request is squashed upon merge, the maintainer can use its title as the final commit message, creating a properly-formatted history.

If your MR contains multiple commits but only one logical change, the [Squash commits when merge request is accepted](https://gitlab.com/help/user/project/merge_requests/squash_and_merge) option (enabled by default in this project) will allow GitLab to use the MR title as the commit message.

#### `<type>`

This describes the kind of change that this commit is providing

- **feat:** A new feature (adding a new component, providing new variants for an existing component, etc.).
- **fix:** A bug fix (correcting a styling issue, addressing a bug in a component's API, etc.).
  When updating non-dev dependencies, mark your changes with the `fix:` type.
- **docs:** Documentation-only changes.
- **style:** Changes that do not affect the meaning of the code
  (whitespace, formatting, missing semicolons, etc). _Not_ to be used for UI changes as those are
  meaningful changes, consider using `feat:` of `fix:` instead.
- **refactor:** A code change that neither fixes a bug nor adds a feature.
- **perf:** A code change that improves performance.
- **test:** Adding missing tests or correcting existing tests.
- **build:** Changes that affect the build system.
- **ci:** Changes to our CI/CD configuration files and scripts.
- **chore:** Other changes that don't modify source or test files. Use this type when adding or
  updating dev dependencies.
- **revert:** Reverts a previous commit.

Each commit type can have an optional scope to specify the place of the commit change: `type(scope):`. It is up to you to add or omit a commit's scope. When a commit affects a specific component, use the component's PascalCase name as the commit's scope. For example:

```plaintext
feat(statusbar): automatically switch pipelines
```

#### `<scope>`

Scope can be anything specifying the place of the commit change. For example events, kafka, userModel, authorization, authentication, loginPage, etc

#### `<description>`

This is a very short description of the change

- `use imperative, present tense: “change” not “changed” nor “changes”`
- `don't capitalize the first letter`
- `no dot (.) at the end`

### Message Body

Just as in the description, use imperative, present tense: “change” not “changed” nor “changes.” Include motivation for the change and contrast it with previous behavior.

#### More info on writing good Git commit messages

- [Writing Git commit messages](http://365git.tumblr.com/post/3308646748/writing-git-commit-messages)
- [A Note About Git Commit Messages](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html)

### Message Footer

Finished, fixed or delivered stories should be listed on a separate line in the footer prefixed with "Finishes", "Fixes" , or "Delivers" keyword like this:

`[(Finishes|Fixes|Delivers) #ISSUE_ID]`

### Message Example

```shell
feat(kafka): implement exactly once delivery

- ensure every event published to kafka is delivered exactly once
- implement error handling for failed delivery

Delivers #065
```

```shell
fix(login): allow provided user preferences to override default preferences

- This allows the preferences associated with a user account to
override and customize the default app preferences like theme or timezone.

Fixes #025
```




